<template>
    <div>
        <table class="table table-hover">
            <thead>
                <tr>
                    <th scope="col">Quarto</th>
                    <th scope="col">Hóspede</th>
                    <th scope="col">Capacidade</th>
                    <th scope="col">Carro</th>
                    <th scope="col">Café</th>
                    <th scope="col">Check-In</th>
                    <th scope="col">Check-Out</th>
                    <th scope="col">Status</th>
                </tr>
            </thead>
            <tbody class="table-group-divider">
                <tr v-if="items.lenght == 0">
                    <td colspan="7">
                        Nenhum quarto reservado!
                    </td>
                </tr>
                <tr v-for="item in paginatedItems" :key="item">
                    <td>{{ item.room }}</td>
                    <td>{{ item.guest }}</td>
                    <td>{{ item.occupation }}/{{ item.capacity }}</td>
                    <td>{{ item.car == "null" ? '-' : item.car }}</td>
                    <td><i :class="item.breakfast ? 'bi bi-check' : 'bi bi-x'"></i></td>
                    <td>{{ item.checkin }}</td>
                    <td>{{ item.checkout }}</td>
                    <td>{{ item.status }}</td>
                </tr>
            </tbody>
        </table>
        <div class="d-flex justify-content-center gap-3">
            <i :class="currentPage == 1 ? 'button bi bi-chevron-left translucent' : 'button bi bi-chevron-left'" @click="currentPage--"></i>
            <i :class="currentPage == Math.ceil(items.length / 10) ? 'button bi bi-chevron-right translucent' : 'button bi bi-chevron-right'" @click="currentPage++"></i>
        </div>
    </div>
</template>

<script>
export default {
    name: 'Table',
    data: () => ({
        itemsPerPage: 10,
        currentPage: 1,
        items: [
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: false,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Reservado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: '',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Ocupado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: '',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Reservado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: false,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Reservado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Ocupado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Reservado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Reservado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Ocupado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Ocupado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Ocupado'
            },
            {
                quarto: '101',
                hospede: 'Mark Zuckerberg',
                capacidade: 3,
                lotacao: 2,
                carro: 'MHU-2449',
                cafe: true,
                checkin: '24/12/2023',
                checkout: '01/01/2024',
                status: 'Ocupado'
            },
            
        ]
    }),
    computed: {
        paginatedItems() {
            const startIndex = (this.currentPage - 1) * this.itemsPerPage;
            const endIndex = startIndex + this.itemsPerPage;
            return this.$store.state.reservations.slice(startIndex, endIndex);
        }
    },
    watch: {
        currentPage() {
            if (this.currentPage < 1) {
                this.currentPage = 1
            }

            if (this.currentPage > Math.ceil(this.items.length / 10)) {
                this.currentPage = Math.ceil(this.items.length / 10)
            }
        }
    },
    mounted() {
        this.$store.commit('refreshInfos')
    }
}
</script>

<style scoped>
.table {
    width: 100%;
    height: 100%;
}

td, th {
    text-align: center;
    background-color: #f4f4f4;
}

.translucent {
    opacity: 0.5;
    cursor: default;
}
</style>